float4 vecSkill1;
texture TargetMap;
texture camera_clean_bmap;
texture depthtex_bmap;

sampler2D smpOriginal = sampler_state
{
	Texture = <camera_clean_bmap>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Wrap;
	AddressV		= Wrap;
};

sampler2D smpScreen = sampler_state
{
	Texture = <TargetMap>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Wrap;
	AddressV		= Wrap;
};

sampler2D smpDepth = sampler_state
{
	Texture = <depthtex_bmap>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Wrap;
	AddressV		= Wrap;
};

float4 Shader(float2 tex : TEXCOORD0) : COLOR
{
	float4 Color1 = tex2D(smpOriginal, tex);
	float4 Color2 = tex2D(smpScreen, tex);
	float Depth = tex2D(smpDepth, tex).r;
	
	float fac = (Depth-vecSkill1.x);
	if(fac < 0)
	{
		fac = -fac/vecSkill1.x;
	}else
	{
		fac -= vecSkill1.y;
		fac *= vecSkill1.z;
	}
	
	float4 Color = lerp(Color1, Color2, saturate(fac));
	
	return Color;
}

technique tech_00
{
	pass pass_00
	{
		VertexShader = null;
		PixelShader = compile ps_2_0 Shader();
	}
}
